import java.util.Comparator;
import java.util.ArrayList;

class DynArrPrioQueue<E> implements PrioQueue<E> {
 ArrayList<E> a;

 Comparator<E> comp;
 
 public DynArrPrioQueue(Comparator<E> comp) {
  this.comp = comp;
  a = new ArrayList<>();
 }

 public void insert(E e) {  // O(n)
  assert invariant();
  for (int i = 0; i < a.size(); i++) {
   if (comp.compare(a.get(i), e) < 0) {
    a.add(i, e);
    return;
   }
  }
  a.add(e);
  assert invariant();
 }
 public E getMin() {  // O(1)
  return a.get(a.size() - 1);
 }
 public E deleteMin() {  // O(1)
  assert invariant();
  E e = a.get(a.size() - 1);
  a.remove(a.size() - 1);
  assert invariant();
  return e;
 }

 boolean invariant() {
  for (int i = 1; i < a.size(); i++) {
   if (comp.compare(a.get(i), a.get(i - 1)) > 0) return false;
  }
  return true;
 }
}